
require 'singleton'
require 'version'
require 'salt/saltfile'
require 'salt/matrix/error'


module Salt  
  
  class Matrix
    include Singleton 
    
    autoload :Cli,  'salt/matrix/cli'

    attr_reader :debug
    
    is_versioned
    
    def initialize
      @debug_buf = []
    end


    def set_debug
      @debug = true
      unless @debug_buf.empty?
        debug {|fh| @debug_buf.each {|m| fh.write "#{m}\n" }}
      end
    end

    def self.set_debug
      self.instance.set_debug
    end


    def debug(msg, &block)
      if block_given?
        yield $stdout
      elsif @debug
        puts "*** #{msg}"
      else
        # just in case we turn debug on in a bit.
        @debug_buf << msg
      end
    end

    def self.debug(msg, &block)
      self.instance.debug(msg, &block)
    end
    
  end
  
end
