

module Salt
  class Matrix
    
    class Error < StandardError
      
      attr_accessor :original
      
      def self.wrap(original, mesg, options = {})
        new(mesg, options).tap do |e|
          e.set_backtrace(caller(4))
          e.original = original
        end
      end
          

      def initialize(mesg, options = {})
        super(mesg)

        bt = options.delete(:backtrace)
        if bt
          set_backtrace(bt)
        end

        @options = options
      end
          
    end
    
  end
  
end